/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-09-01 22:48
**/

#include<bits/stdc++.h>
using namespace std;
namespace R = std::ranges;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
const ll INF = 1LL << 60;

string s;

vector<vector<ll>> d;
bool floyd_warshall(int n){
  for(int k = 0; k < n; k++)
    for(int i = 0; i < n; i++)
      for(int j = 0; j < n; j++)
        if(d[i][k] != INF && d[k][j] != INF)
          d[i][j] =
            min(d[i][j], d[i][k] + d[k][j]);
  for(int i = 0; i < n; i++)
    if(d[i][i] < 0) return 1;
  return 0;
}


ll check_counter(int a, int b){
    // calc table
    d.assign(10, vector<ll>(10, INF));
    R(i, 10){
        d[i][(i + a) % 10] = 1;
        d[i][(i + b) % 10] = 1;
    }
    floyd_warshall(10);

    // calc all gaps
    ll res = 0, tmp;
    F(i, 1, ssize(s)){
        tmp = d[s[i-1] - '0'][s[i] - '0'];
        if(tmp == INF){
            res = -1;
            break;
        }
        res += tmp - 1;
    }
    return res;
}

void solve(){
    // Code goes here ...
    cin >> s;

    R(i, 10){
        R(j, 10)
            cout << check_counter(i, j) << " ";
        cout << endl;
    }
}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    int T = 1;
    /* cin >> T; */
    while(T--)
        solve();

    return 0;
}
        
